# (c) 2023-present Eroax
# (c) 2023-present Yagich
# GNU General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/gpl-3.0.txt)
extends DeckNode


func _init() -> void:
	name = "Get Dictionary Key"
	node_type = "dictionary_get_key"
	description = "Returns the value of a key from a dictionary input, if it exists, or null otherwise."
	category = "general"

	add_input_port(
		DeckType.Types.DICTIONARY,
		"Dictionary"
	)

	add_input_port(
		DeckType.Types.STRING,
		"Key",
		"field"
	)

	add_output_port(
		DeckType.Types.ANY,
		"Value"
	)


func _value_request(_on_port: int) -> Variant:
	var d = request_value(0)
	if d == null:
		return null

	var key = resolve_input_port_value(1)
	if key == null:
		return null

	return d.get(key)
