# (c) 2023-present Eroax
# (c) 2023-present Yagich
# GNU General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/gpl-3.0.txt)
extends DeckNode


func _init() -> void:
	name = "Pass If True"
	node_type = "if_true"
	description = "Pass input if and only if the condition input is true."
	category = "general"

	add_input_port(
		DeckType.Types.BOOL,
		"Condition",
		"checkbox"
	)
	add_input_port(
		DeckType.Types.ANY,
		"Input"
	)

	add_output_port(
		DeckType.Types.ANY,
		"Output"
	)


func _receive(to_input_port: int, data: Variant, extra_data: Array = []) -> void:
	if to_input_port != 1:
		return

	if resolve_input_port_value(0):
		send(0, data, extra_data)
	elif ports[0].value:
		send(0, data, extra_data)


