# (c) 2023-present Eroax
# (c) 2023-present Yagich
# GNU General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/gpl-3.0.txt)
extends DeckNode

var noobs: NoOBSWS

func _init() -> void:
	name = "Set Scene"
	node_type = "obs_set_scene"
	description = "Sets the current scene in OBS."
	category = "obs"

	props_to_serialize = []

	add_input_port(
		DeckType.Types.STRING,
		"Scene Name",
		"field"
	)

	add_input_port(
		DeckType.Types.BOOL,
		"Switch",
		"button"
	)


func _receive(on_input_port: int, _data: Variant, _extra_data: Array = []) -> void:
	if on_input_port != 1:
		return

	if noobs == null:
		noobs = Connections.obs_websocket

	var scene_name: String
	if request_value(0) != null:
		scene_name = request_value(0)
	elif get_input_ports()[0].value_callback.get_object() && get_input_ports()[0].value_callback.call() != "":
		scene_name = get_input_ports()[0].value_callback.call()

	if scene_name.is_empty():
		return

	noobs.make_generic_request(
		"SetCurrentProgramScene",
		{"scene_name": scene_name}
	)
