# (c) 2023-present Eroax
# (c) 2023-present Yagich
# GNU General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/gpl-3.0.txt)
extends DeckNode


func _init() -> void:
	name = "Vector to OBS Position"
	node_type = "obs_vector_to_position"
	description = "Transforms a Vector into a position vector accepted by OBS transform inputs."
	category = "obs"

	add_input_port(
		DeckType.Types.DICTIONARY,
		"Vector"
	)
	add_output_port(
		DeckType.Types.DICTIONARY,
		"Position"
	)


func _value_request(_on_port: int) -> Variant:
	var v = request_value(0)
	if !v:
		return null

	if !(v as Dictionary).has("x") || !(v as Dictionary).has("y"):
		return null

	return {"position_x": v.x, "position_y": v.y}
