# (c) 2023-present Eroax
# (c) 2023-present Yagich
# GNU General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/gpl-3.0.txt)
extends DeckNode


func _init():
	name = "Twitch Send Chat"
	node_type = "twitch_send_chat"
	description = "Sends a message to a Twitch chat."
	category = "twitch"
	
	add_input_port(
		DeckType.Types.STRING, 
		"Message",
		"field"
	)
	add_input_port(
		DeckType.Types.STRING,
		"Channel",
		"field"
	)
	
	add_input_port(
		DeckType.Types.BOOL,
		"Send",
		"button"
	)
	


func _receive(to_input_port, data: Variant, extra_data: Array = []):
	
	if to_input_port != 2:
		
		return
		
	
	var msg = resolve_input_port_value(0)
	var channel = resolve_input_port_value(1)
	
	if channel == null:
		
		channel = ""
	
	if msg == null:
		
		return
		
	
	Connections.twitch.send_chat(msg, channel)

