# (c) 2023-present Eroax
# (c) 2023-present Yagich
# GNU General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/gpl-3.0.txt)
extends DeckNode


func _init() -> void:
	name = "Compose Vector"
	node_type = "vector_compose"
	description = "Returns a vector from two numeric inputs."
	category = "math"

	add_input_port(
		DeckType.Types.NUMERIC,
		"X",
		"field"
	)
	add_input_port(
		DeckType.Types.NUMERIC,
		"Y",
		"field"
	)

	add_output_port(
		DeckType.Types.DICTIONARY,
		"Vector"
	)


func _value_request(_on_port: int) -> Dictionary:
	var x = float(resolve_input_port_value(0))
	var y = float(resolve_input_port_value(1))
	return {"x": x, "y": y}
